; Bit rotation test program for Atmel AVR microcontrollers
; Ingeneering Inc.
; www.ingeninc.com
; Jeff Holtzman
; 2/4/98

;Description
;Rotates a bit through LEDs using precise software time
;delay.  From 10/98 issue of Popular Electronics magazine.
;AUTHOR = Jeff Holtzman
;TARGET = AT90S1200

.device AT90S1200
.cseg
.org 0

.equ    DDRB =  $17
.equ    PORTB = $18
.equ    OLC =   0               ; outer loop count for delay routine
.equ    ILC =   156             ; inner loop count for delay routine

RESET:  ldi     r16, 255                                                        
	out     DDRB, r16       ; set outputs for all  port B.

        ldi     r16, $01        ; initially enable just the lowest bit
LOOP:
        out     PORTB, r16      ; turn on one LED

        ldi     r17, 5          ; wait 0.5 sec
LP1:    rcall   DELAY
        dec     r17
        brne    LP1

        rol     r16             ; rotate the bit
        cpi     r16, $00        ; if all bits not set
        brne    LOOP            ;   ... continue
        inc     r16             ; else set just the lowest bit
        rjmp    LOOP            ; loop forever

DELAY:  ldi     r22, OLC        ; delay for 1/10th second
DL1:    ldi     r23, ILC
DL2:    rcall   DUMMY           ; waste 7 cycles
        dec     r23
        brne    DL2                             
        dec     R22
        brne    DL1
DUMMY:  ret                           

