#include <Folders.h>

CPreferencesFile::CPreferencesFile(unsigned char* fileName,OSType fileType,bool* fileExists=NULL)
{
	char* prefsString=" Preferences";
	
	m_fileName=new unsigned char[fileName[0] + 1 + strlen(prefsString)];
	BlockMove(fileName,m_fileName,(fileName[0] + 1) * sizeof(char));
	
	BlockMove(prefsString,&m_fileName[m_fileName[0] + 1],strlen(prefsString) * sizeof(char));
	
	m_fileName[0]+=strlen(prefsString);
	
	short vRefNum;
	long dirID;
	FSSpec prefsFile;
	
	FindFolder(kOnSystemDisk,kPreferencesFolderType,kDontCreateFolder,&vRefNum,&dirID);
	FSMakeFSSpec(vRefNum,dirID,m_fileName,&prefsFile);
	
	m_prefsRefNum=FSpOpenResFile(&prefsFile,fsRdWrPerm);
	
	if (m_prefsRefNum==-1)
	{
		FSpCreateResFile(&prefsFile,fileType,'pref',smSystemScript);
		m_prefsRefNum=FSpOpenResFile(&prefsFile,fsRdWrPerm);
		if (fileExists)
			*fileExists=false;
	}
	else
	{
		if (fileExists)
			*fileExists=true;
	}
	
	return;
}

bool CPreferencesFile::WritePrefs(void* theData,long theSize)
{
	Handle prefsData=NewHandleClear(theSize),theResource;
	int oldResFile=CurResFile();
	
	HLock(prefsData);
	BlockMove(theData,*prefsData,theSize);
	
	UseResFile(m_prefsRefNum);
	
	CheckForResError();
		
	if (theResource=Get1Resource('PREF',128))
		RemoveResource(theResource);
	
	AddResource(prefsData,'PREF',128,"\pPrefs");
	
	CheckForResError();
	
	ChangedResource(prefsData);
	UpdateResFile(m_prefsRefNum);
	
	CheckForResError();
	
	ReleaseResource(prefsData);
	
	CheckForResError();
	
	HUnlock(prefsData);
	DisposeHandle(prefsData);
	UseResFile(oldResFile);
	
	return true;
}

void CPreferencesFile::ReadPrefs(void** outData)
{
	int oldResFile=CurResFile();
	
	UseResFile(m_prefsRefNum);
	Handle theResource=Get1Resource('PREF',128);
	Handle returnHandle=theResource;
	
	if (!theResource)
	{
		*outData=NULL;
		return;
	}
	
	HandToHand(&returnHandle);
	
	UseResFile(oldResFile);
	
	HLock(returnHandle);
	*outData=*returnHandle;
	DisposeHandle(theResource);
	
	return;
}

CPreferencesFile::~CPreferencesFile()
{
	CloseResFile(m_prefsRefNum);
}