#include "MacAVRpa.h"
#include "FileSupport.h"
#include <TextUtils.h>
#include <DriverServices.h>
#include "TextWindowSupport.h"

AVRFileInfoHandle gAVRHandle;

//  doSaveAsFile

bool  doSaveAsFile(WindowPtr windowPtr)
{
	docStructureHandle			docStrucHdl;
	TEHandle					editRecHdl;
	AVRFileInfoHandle			AVRFileInfoHdl;
	StandardFileReply			fileReply;
	SInt16						fileRefNum;
	SInt32						dataLength;
	Handle						editTextHdl;
	char						filePath[500];
	
	filePath[0] = '\0';
	
	docStrucHdl = (docStructureHandle) (GetWRefCon(windowPtr));
	editRecHdl = (*docStrucHdl)->editRecHdl;
	AVRFileInfoHdl = (*docStrucHdl)->AVRFileInfoHdl;

	StandardPutFile("\pSave as:",(*AVRFileInfoHdl)->AVRFSSpec.name,&fileReply);
	if(fileReply.sfGood)
	{
		SetWTitle(windowPtr,fileReply.sfFile.name);

		if(!(fileReply.sfReplacing))
			FSpCreate(&fileReply.sfFile,'MAVR','TEXT',fileReply.sfScript);

		FSpOpenDF(&fileReply.sfFile,fsCurPerm,&fileRefNum);

		dataLength = (*editRecHdl)->teLength;
		editTextHdl = (*editRecHdl)->hText;
		FSWrite(fileRefNum,&dataLength,*editTextHdl);
		SetEOF(fileRefNum, dataLength);

		FSClose(fileRefNum);
		
		(*AVRFileInfoHdl)->AVRFSSpec.vRefNum = fileReply.sfFile.vRefNum;
		(*AVRFileInfoHdl)->AVRFSSpec.parID = fileReply.sfFile.parID;
		
// 68k		
//		(*AVRFileInfoHdl)->AVRFSSpec.name = new unsigned char[32];

		(*AVRFileInfoHdl)->AVRFSSpec.name[0] = '\0';
		PStrCopy((*AVRFileInfoHdl)->AVRFSSpec.name, fileReply.sfFile.name);
		
		(*AVRFileInfoHdl)->hasBeenSaved = true;
		(*AVRFileInfoHdl)->dirty = false;
		
	} else
	{
		return false;
	}
	return true;
}


//  doSaveFile

bool  doSaveFile(WindowPtr windowPtr)
{
	docStructureHandle			docStrucHdl;
	TEHandle					editRecHdl;
	AVRFileInfoHandle			AVRFileInfoHdl;
	SInt16						fileRefNum;
	SInt32						dataLength;
	Handle						editTextHdl;
	
	docStrucHdl = (docStructureHandle) (GetWRefCon(windowPtr));
	editRecHdl = (*docStrucHdl)->editRecHdl;
	AVRFileInfoHdl = (*docStrucHdl)->AVRFileInfoHdl;

	if((*AVRFileInfoHdl)->hasBeenSaved == true)
	{
		FSpOpenDF(&(*AVRFileInfoHdl)->AVRFSSpec,fsCurPerm,&fileRefNum);

		dataLength = (*editRecHdl)->teLength;
		editTextHdl = (*editRecHdl)->hText;
		FSWrite(fileRefNum,&dataLength,*editTextHdl);
		SetEOF(fileRefNum, dataLength);

		FSClose(fileRefNum);
		
		(*AVRFileInfoHdl)->dirty = false;
	} else
	{
		return(doSaveAsFile(windowPtr));
	}
	return true;
}

void  doRevert(WindowPtr windowPtr)
{
	docStructureHandle			docStrucHdl;
	AVRFileInfoHandle			AVRFileInfoHdl;
	FSSpec 						theSavedFileFSSpec;
	
	docStrucHdl = (docStructureHandle) (GetWRefCon(windowPtr));
	AVRFileInfoHdl = (*docStrucHdl)->AVRFileInfoHdl;

// We need to save the FSSpec because closing the window destroys the reference.
	theSavedFileFSSpec = (*AVRFileInfoHdl)->AVRFSSpec;
	
	doCloseWindow(windowPtr);
	doOpenFile(theSavedFileFSSpec);
}

//  doOpenCommand

void  doOpenCommand(void)
{
	StandardFileReply	fileReply;
	SFTypeList				fileTypes;	

	fileTypes[0] = 'TEXT';

	StandardGetFile(NULL,1,fileTypes,&fileReply);
	if(fileReply.sfGood)
		doOpenFile(fileReply.sfFile);
}

//  doOpenFile

void  doOpenFile(FSSpec fileSpec)
{
	WindowPtr 				windowPtr;
	docStructureHandle		docStrucHdl;
	TEHandle				editRecHdl;
	AVRFileInfoHandle		AVRFileInfoHdl;
	SInt16					fileRefNum;
	SInt32					textLength;
	Handle					textBuffer;

	if((windowPtr = doNewDocWindow()) == NULL)
		return;

	docStrucHdl = (docStructureHandle) (GetWRefCon(windowPtr));;
	editRecHdl = (*docStrucHdl)->editRecHdl;

	SetWTitle(windowPtr,fileSpec.name);

	FSpOpenDF(&fileSpec,fsCurPerm,&fileRefNum);

	SetFPos(fileRefNum,fsFromStart,0);
	GetEOF(fileRefNum,&textLength);

	if(textLength > 32767)
		textLength = 32767;

	textBuffer = NewHandle((Size) textLength);

	FSRead(fileRefNum,&textLength,*textBuffer);

	MoveHHi(textBuffer);
	HLock(textBuffer);

	TESetText(*textBuffer,textLength,editRecHdl);

	HUnlock(textBuffer);
	DisposeHandle(textBuffer);

	FSClose(fileRefNum);

	(*editRecHdl)->selStart = 0;
	(*editRecHdl)->selEnd = 0;
	
// Set up the file info for that window...
	(*docStrucHdl)->AVRFileInfoHdl = new (AVRFileInfo*);
	AVRFileInfoHdl = (*docStrucHdl)->AVRFileInfoHdl;
	gAVRHandle = AVRFileInfoHdl;
	(*AVRFileInfoHdl) = new AVRFileInfo;
	
	(*AVRFileInfoHdl)->AVRFSSpec.vRefNum = fileSpec.vRefNum;
	(*AVRFileInfoHdl)->AVRFSSpec.parID = fileSpec.parID;
//		(*AVRFileInfoHdl)->AVRFSSpec.name = new unsigned char[32];
	(*AVRFileInfoHdl)->AVRFSSpec.name[0] = '\0';
	PStrCopy((*AVRFileInfoHdl)->AVRFSSpec.name, fileSpec.name);
	
	(*AVRFileInfoHdl)->hasBeenSaved = true;
	(*AVRFileInfoHdl)->dirty = false;

	ShowWindow(windowPtr);
}

//  doDrawDataPanel

