#ifndef MACAVRPA_H
#define MACAVRPA_H

#include <AERegistry.h>
#include <Appearance.h>
#include <Balloons.h>	
#include <Controls.h>
#include <Devices.h>
#include <Dialogs.h>
#include <Gestalt.h>
#include <LowMem.h>
#include <Scrap.h>
#include <Sound.h>
#include <StandardFile.h>
#include <ToolUtils.h>
#include <NumberFormatting.h>
#include <TextUtils.h>
#include <ToolUtils.h>
#include <String.h>

#include <stdio.h>
#include "Miscellany.h"
#include "Preferences.h"
#include "CPreferencesFile.h"

//  defines

#define rMenubar				129
#define rWindow					128
#define rVScrollbar			128
#define rErrorStrings		128
#define  eMenuBar				1
#define  eMenu					2
#define  eWindow				3
#define  eDocStructure	4
#define  eEditRecord		5
#define  eExceedChara		6
#define  eNoSpaceCut		7
#define  eNoSpacePaste	8
#define  eProgramming		13
#define  eInstallHandler	14
#define  eCannotOpenFile	15
#define  eGetDescriptorRecord	16
#define  eMissedRequiredParam	17
#define  eGetRequiredParam		18
#define kMaxTELength		32767
#define kTab						0x09
#define kDel						0x7F
#define kReturn					0x0D
#define topLeft(r)			(((Point *) &(r))[0])
#define botRight(r)			(((Point *) &(r))[1])
#define kAboutBoxDialogResID		129
#define kPreferencesDialogResID		132

const int kNumChipsSupported=13;

//  typedefs

typedef struct
{
	FSSpec 				AVRFSSpec;			// The FSSpec for that window.
	Boolean				hasBeenSaved;		// True if the window has a valid FSSpec.
	Boolean				dirty;				// The dirty bit indicates whether the document has
											// been modified since last save.  
} AVRFileInfo, **AVRFileInfoHandle;

struct AVRPrefs
{
	int	portSpeed;	// port speed is stored as a number
	
	short portNumber;	// port number is stored as how far down in the serial port
						// list the desired port.  First port is 1.
						
	int chipType;		// chip type is stored as an index to the StringPtr array
						// gChipList
	
	bool reverseSignature;	// true is reverseSignature is desired
	bool ignoreSignature;	// true if ignoreSignature is desired
	int maxErrors;	// max errors allowed is stored as an int
};

//  function prototypes

void						main								(void);
void						doInitManagers						(void);
void						eventLoop							(void);
void						doIdle								(void);
void						doUpdate							(EventRecord *);
void  						doUpdateModelessDialog				(EventRecord *);
void						doActivate							(EventRecord *);
void  						doActivateModelessDialog			(EventRecord *,Boolean);
void						doErrorAlert						(SInt16);
void  						doCautionAlert						(Str255 theAlertString);
void  						doNoteAlert							(Str255 theAlertString);

extern void					doHelp								(void);

void 						DoAboutBox							(void);
int 						doAssembleProgram					(WindowPtr);
void 						doProgramDevice						(WindowPtr);
void 						doProgramDeviceFromFile				(WindowPtr windowPtr);
Boolean 					IsDialog							(WindowPtr windowPtr);
pascal Boolean 				dialogEventFilter					(DialogPtr,EventRecord *,SInt16 *);
char* 						P2CStrCat							(char*,ConstStr255Param);
char* 						P2CStrCpy							(char*,ConstStr255Param);

//  global variables

extern 						ModalFilterUPP				dialogEventFilterUPP;
extern 						Boolean						gMacOS85Present;
extern 						Boolean						gDone;
extern 						Boolean						gInBackground;
extern 						RgnHandle					gCursorRegion;
extern 						SInt16						gNumberOfWindows;
extern 						SInt16 						gOldControlValue;
extern						AVRPrefs					gThePrefs;
extern						CPreferencesFile*			gThePreferencesFile;
extern						Str255						gChipList[kNumChipsSupported];

#endif
