// 
// Miscellany.h
// 
// 
// This program demonstrates:
//
// 	The use of the determinate progress indicator control to show progress during a
//		time-consuming operation, together with scanning the event queue for Command-period
//		key-down events for the purpose of terminating the lengthy operation before it
//    concludes of its own accord.
//
// 	A 'WIND' resource (purgeable) (initially visible) for a window in which graphics
//		and information relevant to the demonstrations is displayed.
//
// 	A 'DLOG' resource (purgeable), and associated 'DITL', 'dlgx', and 'dftb' resources
//		(purgeable), for a dialog box in which the progress indicator is displayed.
//
// 	'CNTL' resources (purgeable) for the progress indicator dialog.
//
// 	A 'STR#' resource (purgeable) containing the label and narrative strings for the
//		notification-related alert displayed by Miscellany.
//
// 	A 'SIZE' resource with the acceptSuspendResumeEvents, doesActivateOnFGSwitch,
//		canBackgound, and is32BitCompatible flags set.
//
// 

//  includes

#ifndef MISCELLANY_H
#define MISCELLANY_H

#include <Appearance.h>
#include <ColorPicker.h>
#include <Controls.h>
#include <Devices.h>
#include <LowMem.h>
#include <Resources.h>
#include <Retrace.h>
#include <SegLoad.h>
#include <Sound.h>
#include <ToolUtils.h>

#include "MacAVRpa.h"

#define rDialogAssembling		130
#define  iProgressIndicator	1
#define  iMainStatus				2
#define  iProgressStatus		4
#define rDialogSearch				131
#define  iSearchField				4
#define rBarkSound					8192
#define topLeft(r)					(((Point *) &(r))[0])
#define botRight(r)					(((Point *) &(r))[1])

//  typedefs

typedef struct
{
	VBLTask		vblTaskStruc;
	SInt32		thisApplicationsA5;
	Boolean		inVBlankPeriod;
} VBLStructure, *VBLStructurePtr;


extern	ControlHandle 	progressBarHdl;
extern  SInt16					statusMax, statusCurrent;
extern	DialogPtr				gDialogPtr;


//  function prototypes

void				progressBarSegment							(void);
void  			doProgressIndicator							(WindowPtr windowPtr);
Boolean			doCheckForCancel								(DialogPtr);
void  			doIndicatorIterate							();
void 				setStatusText										(char*);
void				setMainStatusText								(char* theTextString);
void  			doDeleteProgressIndicator				(void);


//  in-line glue for GetVBLRec

#if TARGET_CPU_68K
pascal SInt32  GetVBLRec (void) = 0x2E88;
#endif

// 

#endif