// 
// Preferences.c
// 

#include "Preferences.h"
#include "MacAVRpa.h"
#include "TextWindowSupport.h"
#include <CrmSerialDevices.h>
#include <CommResources.h>
#include <ControlDefinitions.h>

#define kPrefsModeless 1

DialogPtr					gPrefsDialogPtr;
PrefsStruc					gPrefsStruc;

//DialogItemType *			statusItemType;
//Rect *						statusBox;



//  global variables

extern WindowPtr	gWindowPtr;
extern RGBColor		gWhiteColour;


//  doProgressBar

void  doPreferences(WindowPtr windowPtr)
{
	RGBColor									redColour = { 0xFFFF, 0x0000, 0x0000 };
	docStructureHandle							docStrucHdl;
	TEHandle									editRecHdl;
	AVRFileInfoHandle							AVRFileInfoHdl;
	long 										numLines = 0;
	Boolean										booleanData;
	ControlHandle								controlHdl;
	SInt16										itemHit;
	MenuHandle									SerialPortMenu;
	Str255										itemString;
	GrafPtr										oldPort;
	int											numSpeeds = 13;
	
	int	portSpeeds[] = {300,600,1200,1800,2400,3600,4800,7200,9600,14400,19200,38400,57600};
	
	DrawMenuBar();

// Set up our numerous handles and stuff:
	if (windowPtr)
	{
		docStrucHdl = (docStructureHandle) (GetWRefCon(windowPtr));;
		AVRFileInfoHdl = (*docStrucHdl)->AVRFileInfoHdl;
		editRecHdl = (*docStrucHdl)->editRecHdl;
	}
	
// Fill serial ports menu
	
	MenuHandle theMenu;
	
	theMenu=GetMenu(133);
	
	CRMRec crmRec;
	CRMRecPtr	crm=&crmRec;
	
	crmRec.crmDeviceType=crmSerialDevice;
	crmRec.crmDeviceID=0;
	
	while (crm=CRMSearch(crm))
	{
		CRMSerialPtr portInfo=(CRMSerialPtr)crm->crmAttributes;
		AppendMenu(theMenu,*(portInfo->name));
	}
	

// Fill port speeds menu
	
	theMenu=GetMenu(134);
	
	for (int i=0;i<numSpeeds;i++)
	{
		Str255 theString;
		
		NumToString(portSpeeds[i],theString);
		AppendMenu(theMenu,theString);
	}
	
// Fill chip list menu

	theMenu=GetMenu(136);
	
	for (int i=0;i<kNumChipsSupported;i++)
		AppendMenu(theMenu,gChipList[i]);
		
	
// Create our sexy dialog box
	if(!(gPrefsDialogPtr = GetNewDialog(rDialogPreferences,NULL,(WindowPtr) -1)))
		ExitToShell();
		
	GetDialogItemAsControl(gPrefsDialogPtr,iPortName,&controlHdl);
	SetControlValue(controlHdl,gThePrefs.portNumber);
//	SetControlValue(controlHdl,0);
//	ExitToShell();
	
	int portSpeedItem;
	
	for (portSpeedItem=0;portSpeedItem<18;portSpeedItem++)
	{
		if (portSpeeds[portSpeedItem]==gThePrefs.portSpeed)
			break;
	}
	
	portSpeedItem++;
	
	GetDialogItemAsControl(gPrefsDialogPtr,iPortSpeed,&controlHdl);
	SetControlValue(controlHdl,portSpeedItem);
	
	GetPort(&oldPort);
	SetPort(gPrefsDialogPtr);

	SetDialogDefaultItem(gPrefsDialogPtr,cButtonDefault);
	SetDialogCancelItem(gPrefsDialogPtr,cButtonCancel);
	SetDialogTracksCursor(gPrefsDialogPtr,true);

	SetWRefCon(gPrefsDialogPtr,(SInt32) kPrefsModeless);
		
	booleanData = true;
	GetDialogItemAsControl(gPrefsDialogPtr,cButtonDefault,&controlHdl);
	SetControlData(controlHdl,kControlNoPart,kControlPushButtonDefaultTag,
									 sizeof(booleanData),(Ptr) &booleanData);

	GetDialogItemAsControl(gPrefsDialogPtr,iChipType,&controlHdl);
	SetControlValue(controlHdl,(gThePrefs.chipType));
	GetDialogItemAsControl(gPrefsDialogPtr,iReverseSignature,&controlHdl);
	SetControlValue(controlHdl,gThePrefs.reverseSignature);
	GetDialogItemAsControl(gPrefsDialogPtr,iIgnoreSignature,&controlHdl);
	SetControlValue(controlHdl,gThePrefs.ignoreSignature);
	GetDialogItemAsControl(gPrefsDialogPtr,iErrorsBox,&controlHdl);
	
	Str255 theString;
	
	NumToString(gThePrefs.maxErrors,theString);
	
	SetDialogItemText((Handle)controlHdl,theString);
	
	if (gThePrefs.ignoreSignature)
	{
		GetDialogItemAsControl(gPrefsDialogPtr,iReverseSignature,&controlHdl);
		HiliteControl(controlHdl,kControlDisabledPart);;
	}

//	ExitToShell();
	ShowWindow(gPrefsDialogPtr);

	UpdateControls(gPrefsDialogPtr,((GrafPtr) gPrefsDialogPtr)->visRgn);

	do
	{
		ModalDialog(dialogEventFilterUPP,&itemHit);
		
		ControlHandle theHandle,theHandle2;

		if ((itemHit==iReverseSignature) || (itemHit==iIgnoreSignature))
		{
			GetDialogItemAsControl(gPrefsDialogPtr,itemHit,&theHandle);
			SetControlValue(theHandle,!GetControlValue(theHandle));
		}
		
		if (itemHit==iIgnoreSignature)
		{
			GetDialogItemAsControl(gPrefsDialogPtr,iReverseSignature,&theHandle);
			GetDialogItemAsControl(gPrefsDialogPtr,iIgnoreSignature,&theHandle2);
			
			if (GetControlValue(theHandle2))
				HiliteControl(theHandle,kControlDisabledPart);
			else
				HiliteControl(theHandle,kControlNoPart);
		}	
	} while((itemHit != cButtonDefault) && (itemHit != cButtonCancel));
	
	GetDialogItemAsControl(gPrefsDialogPtr,iPortName,&controlHdl);
	gThePrefs.portNumber=GetControlValue(controlHdl);
	GetDialogItemAsControl(gPrefsDialogPtr,iPortSpeed,&controlHdl);
	gThePrefs.portSpeed=portSpeeds[GetControlValue(controlHdl) - 1];
	GetDialogItemAsControl(gPrefsDialogPtr,iReverseSignature,&controlHdl);
	gThePrefs.reverseSignature=GetControlValue(controlHdl);
	GetDialogItemAsControl(gPrefsDialogPtr,iIgnoreSignature,&controlHdl);
	gThePrefs.ignoreSignature=GetControlValue(controlHdl);
	GetDialogItemAsControl(gPrefsDialogPtr,iChipType,&controlHdl);
	gThePrefs.chipType=(GetControlValue(controlHdl));

	StringPtr theText = new unsigned char[10];
	long value;

	GetDialogItemAsControl(gPrefsDialogPtr,iErrorsBox,&controlHdl);
	GetDialogItemText((Handle)controlHdl,theText);

	StringToNum(theText,&value);
	
	gThePrefs.maxErrors=value;

	DisposeDialog(gPrefsDialogPtr);
	
	gPrefsDialogPtr = NULL;
	SetPort(oldPort);
}

void CheckPreferences()
{
	bool fileExists;
	AVRPrefs* tempPrefs;
	
	gThePreferencesFile=new CPreferencesFile("\pMacAVRpa 2.0",'MAVR',&fileExists);
	
	if (!fileExists)
		doPreferences(NULL);
	else
	{
		gThePreferencesFile->ReadPrefs((void**)&tempPrefs);
		gThePrefs=*tempPrefs;
	}
}