// 
// Miscellany.h
// 
// 
// This program demonstrates:
//
// 	The use of the determinate progress indicator control to show progress during a
//		time-consuming operation, together with scanning the event queue for Command-period
//		key-down events for the purpose of terminating the lengthy operation before it
//    concludes of its own accord.
//
// 	A 'WIND' resource (purgeable) (initially visible) for a window in which graphics
//		and information relevant to the demonstrations is displayed.
//
// 	A 'DLOG' resource (purgeable), and associated 'DITL', 'dlgx', and 'dftb' resources
//		(purgeable), for a dialog box in which the progress indicator is displayed.
//
// 	'CNTL' resources (purgeable) for the progress indicator dialog.
//
// 	A 'STR#' resource (purgeable) containing the label and narrative strings for the
//		notification-related alert displayed by Miscellany.
//
// 	A 'SIZE' resource with the acceptSuspendResumeEvents, doesActivateOnFGSwitch,
//		canBackgound, and is32BitCompatible flags set.
//
// 

//  includes

#ifndef PREFERENCES_H
#define PREFERENCES_H


#include <Appearance.h>
#include <ColorPicker.h>
#include <Controls.h>
#include <Devices.h>
#include <Fonts.h>
#include <LowMem.h>
#include <Menus.h>
#include <NumberFormatting.h>
#include <Processes.h>
#include <Resources.h>
#include <Sound.h>
#include <ToolUtils.h>
#include "MacAVRpa.h"

//  defines

#define rDialogPreferences	132
#define cPortName						133
#define iPortName						4
#define cPortSpeed					134
#define iPortSpeed					5
#define cButtonDefault			2
#define cButtonCancel				3
#define mSerialPort					133

#define iChipType			6
#define iReverseSignature	7
#define iIgnoreSignature	8
#define	iErrorsBox			9

#define MAXLONG						0x7FFFFFFF
#define MIN(a,b) 					((a) < (b) ? (a) : (b))


#define topLeft(r)					(((Point *) &(r))[0])
#define botRight(r)					(((Point *) &(r))[1])

//  typedefs

typedef struct
{
	ControlHandle	popupPortNameHdl;
	ControlHandle	popupPortSpeedHdl;
} PrefsStruc, **PrefsStrucHdl;


extern	DialogPtr				gPrefsDialogPtr;
extern  PrefsStruc			gPrefsStruc;


//  function prototypes

// void				progressBarSegment							(void);
void  			doPreferences							(WindowPtr windowPtr);
void				CheckPreferences();
//Boolean			doCheckForCancel								(DialogPtr);
//void  			doIndicatorIterate							();
//void 				setStatusText										(char*);
//void  			doDeleteProgressIndicator				(void);

//  in-line glue for GetVBLRec

#if TARGET_CPU_68K
pascal SInt32  GetVBLRec (void) = 0x2E88;
#endif

// 

#endif