// 
// ProgressIndicator.c
// 

#include "Miscellany.h"
#include "TextWindowSupport.h"

ControlHandle 	progressBarHdl = NULL;
char**				 	progressStatusHdl;
char**					mainStatusHdl;
SInt16					statusMax = 3456;
SInt16					statusCurrent = 3456;
DialogPtr				gDialogPtr = NULL;
DialogItemType *					statusItemType;
Rect *										statusBox;



//  global variables

extern WindowPtr	gWindowPtr;
extern RGBColor		gWhiteColour;

//  progressBarSegment

void  progressBarSegment(void) {}

//  doProgressBar

void  doProgressIndicator(WindowPtr windowPtr)
{
	RGBColor									redColour = { 0xFFFF, 0x0000, 0x0000 };
	docStructureHandle							docStrucHdl;
	TEHandle									editRecHdl;
	long 										numLines = 0;


// Set up our numerous handles and stuff:
	docStrucHdl = (docStructureHandle) (GetWRefCon(windowPtr));;
//	AVRFileInfoHdl = (*docStrucHdl)->AVRFileInfoHdl;
	editRecHdl = (*docStrucHdl)->editRecHdl;
	
// Create our sexy dialog box
	if(!(gDialogPtr = GetNewDialog(rDialogAssembling,NULL,(WindowPtr) -1)))
		ExitToShell();

	SetPort(gDialogPtr);
	UpdateControls(gDialogPtr,((GrafPtr) gDialogPtr)->visRgn);
	SetPort(windowPtr);

	GetDialogItemAsControl(gDialogPtr,iProgressIndicator,&progressBarHdl);
    GetDialogItem					(gDialogPtr,iProgressStatus, statusItemType, &progressStatusHdl,  statusBox);
    GetDialogItem					(gDialogPtr,iMainStatus, statusItemType, &mainStatusHdl,  statusBox);

// Find the number of lines that are used.
// We multiply the result by two because we do two passes over the data.
	numLines = (*editRecHdl)->nLines * 2;


	statusMax = numLines;
	statusCurrent = 0;
	SetControlMaximum(progressBarHdl,statusMax);
	
	setdialogitemtext(progressStatusHdl,"This is a test.");
	UpdateControls(gDialogPtr,((GrafPtr) gDialogPtr)->visRgn);


}

void  doIndicatorIterate()
{
	Handle				soundHdl;

    if(statusCurrent < statusMax)
    {
			if(doCheckForCancel(gDialogPtr))
			{
				soundHdl = GetResource('snd ',rBarkSound);
				SndPlay(NULL,(SndListHandle) soundHdl,false);
				ReleaseResource(soundHdl);
				DisposeDialog(gDialogPtr);
				statusCurrent = statusMax + 1;

				return;
			}
			
			SetControlValue(progressBarHdl,statusCurrent++);
		}
		
		if(statusCurrent == statusMax)
		{
				statusCurrent++;
				if(gDialogPtr != NULL)
				{
					DisposeDialog(gDialogPtr);		
					gDialogPtr = NULL;
				}	
		}

}

//  doCheckForCancel

Boolean  doCheckForCancel(DialogPtr dialogPtr) 
{
	GrafPtr		oldPort;
	Boolean		foundCommandPeriod;
	QHdrPtr		eventQHdrPtr;
	EvQElPtr	eventQElPtr;
	SInt32		charCode;
	SInt32		commandKeyDown;

	GetPort(&oldPort);
	SetPort(dialogPtr);

	foundCommandPeriod = false;

	eventQHdrPtr = LMGetEventQueue();
	eventQElPtr = (EvQElPtr) eventQHdrPtr->qHead;

	while(eventQElPtr && !foundCommandPeriod)
	{
		if(eventQElPtr->evtQWhat == keyDown)
		{
			charCode = eventQElPtr->evtQMessage & charCodeMask;
			commandKeyDown = eventQElPtr->evtQModifiers & cmdKey;

			if(commandKeyDown)
				if(charCode == 0x2e)
					foundCommandPeriod = true;
		}

		if(!foundCommandPeriod)
			eventQElPtr = (EvQElPtr) eventQElPtr->qLink;
	}

	SetPort(oldPort);
	
	return(foundCommandPeriod);
}

// 

void setStatusText(char* theTextString)
{
	setdialogitemtext(progressStatusHdl,theTextString);
	UpdateControls(gDialogPtr,((GrafPtr) gDialogPtr)->visRgn);
}

void setMainStatusText(char* theTextString)
{
	setdialogitemtext(mainStatusHdl,theTextString);
	UpdateControls(gDialogPtr,((GrafPtr) gDialogPtr)->visRgn);
}

void  doDeleteProgressIndicator()
{
	if(gDialogPtr != NULL)
	{
		DisposeDialog(gDialogPtr);		
		gDialogPtr = NULL;
	}	

}

