/***********************************************************************
 *  args - Argument reading system
 *  Copyright (C) 1997-1998 Jon Anders Haugum
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; see the file COPYING.  If not, write to
 *  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *  Boston, MA 02111-1307, USA.
 *
 *
 *  Author of args can be reached at:
 *     email: jonah@colargol.tihlde.hist.no
 *     www: http://www.colargol.tihlde.hist.no/~jonah/el/avrp.html
 *     Postal address: Jon Anders Haugum
 *                     vre Mllenbergsgt 52
 *                     7014 Trondheim
 */

enum
	{
	ARGTYPE_BOOLEAN = 0,   /* boolean Value (0 = False) */
	ARGTYPE_STRING,        /* Stringpointer in Data     */
	ARGTYPE_STRING_MULTI   /* List of strings in Data   */
	};

struct avrpargs
	{
	struct avrparg *thearg;
	int count;
	struct data_list *first_data;
	};

struct avrparg
	{
	int type;
	char letter;
	char *longarg;
	void *data;
	};

struct data_list
	{
	struct data_list *next;
	void *data;
	};

struct avrpargs *alloc_avrpargs(int arg_count);
int read_avrpargs(struct avrpargs *avrpargs, int argc, char *argv[]);
void free_avrpargs(struct avrpargs *avrpargs);
void define_avrparg(struct avrpargs *avrpargs, int index, int type, char letter, char *longarg, void *def_value);
void * GET_avrparg(avrpargs*, int);
void SET_avrparg(avrpargs*, int, void *);
